#include	<gtk/gtkfilesel.h>
#include	<stdlib.h>
#include	<string.h>

/*
void       gtk_file_selection_set_filename        (GtkFileSelection *filesel, const gchar      *filename);
*/

struct fs_query
{
	GtkFileSelection	*fs;
	char				*str;	// null if cancelled
};

void store_filename(GtkWidget *button, struct fs_query	*q)
{
	char	*sel = gtk_file_selection_get_filename(q->fs);
	q->str = malloc(strlen(sel)+1);
	strcpy(q->str, sel);
	gtk_widget_destroy((GtkWidget*)q->fs);
	gtk_main_quit();
}

void handle_cancel(GtkWidget *button, struct fs_query	*q)
{
	q->str = 0;
	gtk_widget_destroy((GtkWidget*)q->fs);
	gtk_main_quit();
}

char	*gtk_filesel(char	*prompt, char	*pattern)
{
	struct fs_query	q;
	static int	is_gtk_inited = 0;

	if(!is_gtk_inited)
	{
		gtk_init(0, 0);
		is_gtk_inited = 1;
	}

	q.fs = (GtkFileSelection*)gtk_file_selection_new("Pick a file!");
	gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION(q.fs)->ok_button), 
					"clicked", GTK_SIGNAL_FUNC (store_filename), (gpointer) &q);
	gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION(q.fs)->cancel_button), 
					"clicked", GTK_SIGNAL_FUNC (handle_cancel), (gpointer) &q);
	if(pattern)gtk_file_selection_complete(q.fs, pattern);
	gtk_widget_show((GtkWidget*)q.fs);
	gtk_main();
	return q.str;
}
